﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace JeuAvecDesKilometres
{
    public abstract class Carte : IComparable<Carte>
    {
        /// <summary>
        /// Constructeur protégé, seules les classes filles pourront l'appeler
        /// </summary>
        /// <param name="CheminDeLimage"></param>
        /// <param name="LesPoints"></param>
        protected Carte(string CheminDeLimage, int LesPoints)
        {
            CheminImage = CheminDeLimage;
            Points = LesPoints;
        }

        /// <summary>
        /// Chemin vers l'image de la face
        /// </summary>
        /// <remarks>C'est la couche Vue qui s'occupera de l'afficher</remarks>
        public string CheminImage { get; private set; }//private set, car seule l'instance peut affecter/modifier son image

        /// <summary>
        /// Nombre de points marqués avec cette carte
        /// </summary>
        public int Points { get; protected set; }//private set, car seule l'instance ou une instance dérivée peut affecter/modifier les points

        /// <summary>
        /// Propriété pour le tri
        /// </summary>
        public abstract int Ordre
        { 
            get; 
        }

        /// <summary>
        /// Implémentation de IComparable<Carte>
        /// </summary>
        /// <param name="other"></param>
        /// <returns></returns>
        public int CompareTo(Carte other)
        {
            return this.Ordre.CompareTo(other.Ordre);
        }
    }

}
