﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace JeuAvecDesKilometres
{
    public class Embuche : Carte
    {
        public Embuche(string CheminImage, TypeEmbuche LeType)
            : base(CheminImage, 0)
        {
            Type = LeType;
        }

        public TypeEmbuche Type { get; private set; }

        /// <summary>
        /// Une embûche est lancée à un autre joueur
        /// </summary>
        /// <param name="Cible"></param>
        public void Jouer(Joueur Cible)
        {
            //ToDo implémenter le jeu de l'embuche
        }

        /// <summary>
        /// Réécriture de ToString pour afficher le nom de l'embûche
        /// </summary>
        /// <returns></returns>
        public override string ToString()
        {
            return Type.ToString();
        }

        /// <summary>
        /// Méthode de classe qui génère la liste d'Embuches
        /// </summary>
        /// <returns></returns>
        public static List<Carte> Generer()
        {
            List<Carte> resultat = new List<Carte>();

            for (int i = 0; i < 5; i++)
            {
                resultat.Add(new Embuche("Image du feu rouge", TypeEmbuche.FeuRouge));
            }

            for (int i = 0; i < 4; i++)
            {
                resultat.Add(new Embuche("Image de la limitation de vitesse", TypeEmbuche.LimitationVitesse));
            }

            for (int i = 0; i < 3; i++)
            {
                resultat.Add(new Embuche("Image de la panne d'essence", TypeEmbuche.PanneEssence));
            }

            for (int i = 0; i < 3; i++)
            {
                resultat.Add(new Embuche("Image de la crevaison", TypeEmbuche.Crevaison));
            }

            for (int i = 0; i < 3; i++)
            {
                resultat.Add(new Embuche("Image de l'accident", TypeEmbuche.Accident));
            }

            return resultat;
        }

        /// <summary>
        /// Implémentation de ordre dans Embuche
        /// </summary>
        public override int Ordre
        {
            get { return (int)Type + 3; }
        }

    }
}
