﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace JeuAvecDesKilometres
{
    public class Kilometre : Carte
    {
        public Kilometre(string CheminDeLimage, int LesKilometres)
            : base(CheminDeLimage, LesKilometres)//on appelle le constructeur de Carte
        {
            Distance = LesKilometres;
        }

        public int Distance { get; private set; }

        /// <summary>
        /// Réécriture de ToString pour afficher le nombre de kilomètres
        /// </summary>
        /// <returns></returns>
        public override string ToString()
        {
            return Distance.ToString() + " km";
        }

        /// <summary>
        /// Méthode de classe qui génère la liste de Kilomètres
        /// </summary>
        /// <returns></returns>
        public static List<Carte> Generer()
        {
            List<Carte> resultat = new List<Carte>();

            for (int i = 0; i < 10; i++)
            {
                resultat.Add(new Kilometre("Image 25 km", 25));
            }

            for (int i = 0; i < 10; i++)
            {
                resultat.Add(new Kilometre("Image 50 km", 50));
            }

            for (int i = 0; i < 10; i++)
            {
                resultat.Add(new Kilometre("Image 75 km", 75));
            }

            for (int i = 0; i < 12; i++)
            {
                resultat.Add(new Kilometre("Image 100 km", 100));
            }

            for (int i = 0; i < 4; i++)
            {
                resultat.Add(new Kilometre("Image 200 km", 200));
            }


            return resultat;
        }

        /// <summary>
        /// Opérateur qui permet d'additionner deux Kilometre et de retourner un entier égal à la somme des distances.
        /// </summary>
        /// <param name="LUn"></param>
        /// <param name="LAutre"></param>
        /// <returns></returns>
        public static int operator +(Kilometre LUn, Kilometre LAutre)
        {
            return LUn.Distance + LAutre.Distance;
        }

        /// <summary>
        /// Opérateur qui permet d'additionner un Kilometre et un entier
        /// </summary>
        /// <param name="Km"></param>
        /// <param name="Entier"></param>
        /// <returns></returns>
        public static int operator +(Kilometre Km, int Entier)
        {
            return Km.Distance + Entier;
        }

        /// <summary>
        /// Implémentation de ordre Kilometre
        /// </summary>
        public override int Ordre
        {
            get { return Distance + 20; }
        }
    }
}
