﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace JeuAvecDesKilometres
{
    public class Parade : Carte
    {
        public Parade(string CheminImage, TypeEmbuche LeType)
            : base(CheminImage, 0)
        {
            EmbucheParee = LeType;
        }

        public TypeEmbuche EmbucheParee { get; private set; }//plutôt que de définir un lien entre un type de parade et le type d'embuche, il est aussi simple définir l'embuche parée

        /// <summary>
        /// Réécriture de ToString pour afficher le nom de la parade
        /// </summary>
        /// <returns></returns>
        public override string ToString()
        {
            switch (EmbucheParee)
            {
                case TypeEmbuche.Accident:
                    return "Réparation";

                case TypeEmbuche.Crevaison:
                    return "Roue de secours";

                case TypeEmbuche.FeuRouge:
                    return "Feu vert";

                case TypeEmbuche.LimitationVitesse:
                    return "Fin de limitation";

                case TypeEmbuche.PanneEssence:
                    return "Station essence";

                default: //on est obligé de mettre un default ou après le switch return quelque chose car ToString retourne un résultat, et même si on a testé toutes les options de TypeEmbuche, le compilateur considère qu'un cas non prévu pourrait se présenter et qu'il n'y aurait alors pas de résultat
                    return "Erreur";
            }
        }

        /// <summary>
        /// Méthode de classe qui génère la liste de Parades
        /// </summary>
        /// <returns></returns>
        public static List<Carte> Generer()
        {
            List<Carte> resultat = new List<Carte>();

            for (int i = 0; i < 14; i++)
            {
                resultat.Add(new Parade("Image du feu vert", TypeEmbuche.FeuRouge));
            }

            for (int i = 0; i < 6; i++)
            {
                resultat.Add(new Parade("Image de la fin de limitation", TypeEmbuche.LimitationVitesse));
            }

            for (int i = 0; i < 6; i++)
            {
                resultat.Add(new Parade("Image de la station essence", TypeEmbuche.PanneEssence));
            }

            for (int i = 0; i < 6; i++)
            {
                resultat.Add(new Parade("Image de la roue de secours", TypeEmbuche.Crevaison));
            }

            for (int i = 0; i < 6; i++)
            {
                resultat.Add(new Parade("Image de la réparation", TypeEmbuche.Accident));
            }

            return resultat;
        }

        /// <summary>
        /// Implémentation de ordre dans Parade
        /// </summary>
        public override int Ordre
        {
            get
            {
                if (EmbucheParee == TypeEmbuche.FeuRouge)
                    return 4;
                else
                    return (int)EmbucheParee + 4;
            }
        }

    }
}
