﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using JeuAvecDesKilometres;//pour pouvoir me réfèrer à cet espace de nom, j'ai d'abord mis la réfèrence au projet JeuAvecDesKilometres dans le porjet actuel

namespace Tuto_Objets_Csharp_winform
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Dictionary<string, Difficulte> nomsJoueurs = new Dictionary<string, Difficulte>();
            nomsJoueurs.Add("Joueur A", Difficulte.Normale);
            nomsJoueurs.Add("Joueur B", Difficulte.Normale);
            nomsJoueurs.Add("Joueur C", Difficulte.Normale);

            Moteur.InitPremierePartie(nomsJoueurs);

            //Début débug
            
            //on remets les cartes dans la pioche
            foreach (Joueur j in Moteur.Joueurs)
            {
                foreach (Carte c in j.Main)
                    Moteur.Pioche.Add(c);

                j.Main.Clear();
            }


            Carte laCarte = Moteur.Pioche.OfType<Botte>().Single(b => b.EmbucheImmunisee.HasFlag(TypeEmbuche.FeuRouge));//on donne le camion de pompier à A
            Moteur.Joueurs[0].Main.Add(laCarte);
            Moteur.Pioche.Remove(laCarte);

            laCarte = Moteur.Pioche.OfType<Botte>().Single(b => b.EmbucheImmunisee.HasFlag(TypeEmbuche.Accident));//on donne l'As du Volant à A
            Moteur.Joueurs[0].Main.Add(laCarte);
            Moteur.Pioche.Remove(laCarte);

            var kms = Moteur.Pioche.OfType<Kilometre>().Where(k => k.Distance == 100);//on donne des 100km à A
            for (int i = 0; i < 5; i++)
            {
                Carte c = kms.First();
                Moteur.Pioche.Remove(c);
                Moteur.Joueurs[0].Main.Add(c);

            }

            laCarte = Moteur.Pioche.First(c => c is Embuche && ((Embuche)c).Type.HasFlag(TypeEmbuche.Accident));//on donne un Accident à B
            Moteur.Pioche.Remove(laCarte);
            Moteur.Joueurs[1].Main.Add(laCarte);
            for (int i = 0; i < 5; i++)//On pioche normalement pour B et C
            {
                Moteur.Joueurs[1].Pioche();
                Moteur.Joueurs[2].Pioche();
            }
            Moteur.Joueurs[2].Pioche();

            
            //fin débug

            Moteur.PartieGagnee += Moteur_PartieGagnee;
            Moteur.ProchainJoueur += Moteur_ProchainJoueur;
            Moteur.NouvellePioche += Moteur_NouvellePioche;
            Moteur.CarteInterdite += Moteur_CarteInterdite;
            Moteur.CoupFourre += Moteur_CoupFourre;
            Moteur.JoueurDisqualifie += Moteur_JoueurDisqualifie;
            Moteur.PiocheDabord += Moteur_PiocheDabord;

            Moteur_ProchainJoueur(Moteur.JoueurEnCours);

            TousLesBinding();
        }

        void Moteur_PiocheDabord(Joueur LeJoueur)
        {
            AfficheMessage(LeJoueur.Nom + " doit piocher avant de jouer.");
        }

        void Moteur_JoueurDisqualifie(Joueur LeJoueur)
        {
            AfficheMessage(LeJoueur.Nom + " a dépassé la distance, il est disqualifié!");
        }

        void Moteur_CoupFourre()
        {
            AfficheMessage("Coup fourré!");
        }

        void Moteur_CarteInterdite(Joueur LeJoueur, Carte LaCarte, Interdictions Raison)
        {
            string[] messages = {"Joueur immunisé","Limitation de vitesse","Embûche à parer","2 cartes 200 km maximum","Parade inutile",
                                "Parez l'embûche avant de poser le feu vert","La cible est déjà attaquée","Joueur déjà bridé",
                                "Carte interdite pour une raison inconnue","Distance dépassée","Veuillez patienter","Ce n'est pas votre tour","Pioche interdite"};
            AfficheMessage(messages[(int)Raison]);
        }

        void Moteur_NouvellePioche()
        {
            lblPioche.Text = string.Format("La pioche contient\r\n{0} cartes.", Moteur.Pioche.Count);
            TousLesBinding();
        }

        void Moteur_ProchainJoueur(Joueur LeJoueur)
        {
            lblA.BackColor = Color.Transparent;
            lblB.BackColor = Color.Transparent;
            lblC.BackColor = Color.Transparent;


            switch (Moteur.Joueurs.IndexOf(LeJoueur))
            {
                //mets le nom du joueur en vert
                case 0:
                    lblA.BackColor = Color.Lime;
                    break;

                case 1:
                    lblB.BackColor = Color.Lime;
                    break;

                case 2:
                    lblC.BackColor = Color.Lime;
                    break;
            }

            butPiocher.Visible = LeJoueur.Niveau != Difficulte.Facile;

        }

        void Moteur_PartieGagnee(Joueur LeJoueur)
        {
            TousLesBinding();

            Joueur lautre = Moteur.Joueurs.Single(j => j != LeJoueur);
            StringBuilder str = new StringBuilder(LeJoueur.Nom);
            str.AppendLine(" a gagné!");
            str.AppendLine(string.Format("{0} marque {1} points.", LeJoueur.Nom,LeJoueur.Points));
            str.AppendLine(string.Format("{0} marque {1} points.", lautre.Nom, lautre.Points));


            MessageBox.Show(str.ToString());

            Moteur.NouvellePartie();
        }

        private void butPiocher_Click(object sender, EventArgs e)
        {
            Joueur leJoueur = Moteur.JoueurEnCours;
            leJoueur.Pioche();

            ListBox lst;
            if (leJoueur == Moteur.Joueurs[0])
                lst = lstMainA;
            else
                lst = lstMainB;

            TousLesBinding();
        }

            Carte laCarte;
            Joueur joueur;
        private void butJouer_Click(object sender, EventArgs e)
        {

            if(sender == butJouerA)
            {
                laCarte = (Carte)lstMainA.SelectedItem;
                joueur = Moteur.Joueurs[0];
            }
            else if(sender == butJouerB)
            {
                laCarte = (Carte)lstMainB.SelectedItem;
                joueur = Moteur.Joueurs[1];
            }
            else
            {
                laCarte = (Carte)lstMainC.SelectedItem;
                joueur = Moteur.Joueurs[2];
            }



            if (laCarte is Embuche)
            {

                lstCible.DataSource = null;
                lstCible.DataSource = Moteur.Joueurs.Except(new[] { joueur }).ToList() ;
                lstCible.SelectedItem = -1;
                lstCible.Visible = true;
                return;
            }
            else if (laCarte is Kilometre)
                joueur.Jouer((Kilometre)laCarte);
            else if (laCarte is Parade)
                joueur.Jouer((Parade)laCarte);
            else
                joueur.Jouer((Botte)laCarte);

            TousLesBinding();
        }

        private void butDefausser_Click(object sender, EventArgs e)
        {
            Carte laCarte;
            if (Moteur.JoueurEnCours == Moteur.Joueurs[0])
                laCarte = (Carte)lstMainA.SelectedItem;
            else if (Moteur.JoueurEnCours == Moteur.Joueurs[1])
                laCarte = (Carte)lstMainB.SelectedItem;
            else 
                laCarte = (Carte)lstMainC.SelectedItem;

            Moteur.JoueurEnCours.Defausse(laCarte);
            TousLesBinding();
        }

        private void TousLesBinding()
        {
            lstJeuA.DataSource = null;
            lstJeuB.DataSource = null;
            lstJeuC.DataSource = null;
            lstMainA.DataSource = null;
            lstMainB.DataSource = null;
            lstMainC.DataSource = null;

            lblMainA.Text = string.Format("Main, {0} cartes", Moteur.Joueurs[0].Main.Count);
            lstMainA.DataSource = Moteur.Joueurs[0].Main;
            lstJeuA.DataSource = Moteur.Joueurs[0].Jeu;
			lblJeuA.Text = Moteur.Joueurs[0].DistanceParcourue.ToString() + " km";
			lblImmuniteA.Text = Moteur.Joueurs[0].Immunite.ToString();
			lblEmbuchesA.Text = Moteur.Joueurs[0].EmbucheEnCours.ToString();

            lblMainB.Text = string.Format("Main, {0} cartes", Moteur.Joueurs[1].Main.Count);
            lstMainB.DataSource = Moteur.Joueurs[1].Main;
            lstJeuB.DataSource = Moteur.Joueurs[1].Jeu;
			lblJeuB.Text = Moteur.Joueurs[1].DistanceParcourue.ToString() + " km";
			lblImmuniteB.Text = Moteur.Joueurs[1].Immunite.ToString();
            lblEmbuchesB.Text = Moteur.Joueurs[1].EmbucheEnCours.ToString();

            lblMainC.Text = string.Format("Main, {0} cartes", Moteur.Joueurs[2].Main.Count);
            lstMainC.DataSource = Moteur.Joueurs[2].Main;
            lstJeuC.DataSource = Moteur.Joueurs[2].Jeu;
            lblJeuC.Text = Moteur.Joueurs[2].DistanceParcourue.ToString() + " km";
            lblImmuniteC.Text = Moteur.Joueurs[2].Immunite.ToString();
            lblEmbuchesC.Text = Moteur.Joueurs[2].EmbucheEnCours.ToString();
            
            lstDefausse.DataSource = null;
            lstDefausse.DataSource = Moteur.Defausse;

            lblPioche.Text = string.Format("La pioche contient\r\n{0} cartes.", Moteur.Pioche.Count);

        }

        private void AfficheMessage(string Message)
        {
            LblAnnonce.Text = Message;
            timer1.Start();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            if (timer1.Interval == 10)
            {
                timer1.Interval = 3000;
                LblAnnonce.Visible = true;
            }
            else
            {
                timer1.Stop();
                timer1.Interval = 10;
                LblAnnonce.Visible = false;
            }

        }

        private void butPiocher_Click_1(object sender, EventArgs e)
        {
            Moteur.JoueurEnCours.Pioche();

            TousLesBinding();
        }

        private void lstCible_Click(object sender, EventArgs e)
        {
            joueur.Jouer((Embuche)laCarte, (Joueur)lstCible.SelectedItem);
            lstCible.Visible = false;
            TousLesBinding();
        }
    }
}
