﻿Imports System.Text
Imports System.Threading.Tasks

Namespace JeuAvecDesKilometres
    Public Class Botte
        Inherits Carte
        Public Sub New(ByVal CheminImage As String, ByVal LeType As TypeEmbuche)
            MyBase.New(CheminImage, 100)
            EmbucheImmunisee = LeType
        End Sub

        Private privateEmbucheImmunisee As TypeEmbuche
        Public Property EmbucheImmunisee As TypeEmbuche
            Get
                Return privateEmbucheImmunisee
            End Get
            Private Set(ByVal value As TypeEmbuche)
                privateEmbucheImmunisee = value
            End Set
        End Property

        ''' <summary>
        ''' Réécriture de ToString pour afficher le nom de la botte
        ''' </summary>
        ''' <returns></returns>
        Public Overrides Function ToString() As String
            Select Case EmbucheImmunisee
                Case TypeEmbuche.Accident
                    Return "As du volant"

                Case TypeEmbuche.Crevaison
                    Return "Roue increvable"

                Case TypeEmbuche.FeuRouge Or TypeEmbuche.LimitationVitesse
                    Return "Camion de pompier"

                Case TypeEmbuche.PanneEssence
                    Return "Citerne d'essence"
            End Select

            'on est obligé de mettre un default ou aprés le swicth return quelque chose car ToString retourne un résultat, et même si on a testé toutes les options de TypeEmbuche, le compilateur considère qu'un cas non prévu pourrait se présenter et qu'il n'y aurait alors pas de résultat
            Return "Erreur"
        End Function

        ''' <summary>
        ''' Cette méthode est appelée par le joueur en cas de coup fourré
        ''' </summary>
        Public Sub CoupFourreParLeJoueur()
            Me.Points += 300
        End Sub

        ''' <summary>
        ''' Méthode de classe qui génère la liste de Bottes
        ''' </summary>
        ''' <returns></returns>
        Public Shared Function Generer() As List(Of Carte)
            Dim resultat As New List(Of Carte)()

            resultat.Add(New Botte("Image du camion de pompier", TypeEmbuche.FeuRouge Or TypeEmbuche.LimitationVitesse))
            resultat.Add(New Botte("Image de la citerne d'essence", TypeEmbuche.PanneEssence))
            resultat.Add(New Botte("Image de la roue increvable", TypeEmbuche.Crevaison))
            resultat.Add(New Botte("Image de l'as du volant", TypeEmbuche.Accident))

            Return resultat
        End Function

        ''' <summary>
        ''' Implémentation de ordre dans Botte
        ''' </summary>
        Public Overrides ReadOnly Property Ordre As Integer
            Get
                Select Case EmbucheImmunisee
                    Case TypeEmbuche.Accident 'As du Volant
                        Return 0

                    Case TypeEmbuche.FeuRouge Or TypeEmbuche.LimitationVitesse 'Camion de Pompier
                        Return 1

                    Case TypeEmbuche.PanneEssence 'Citerne d'essence
                        Return 2

                    Case Else 'il ne reste que la roue de secours
                        Return 3
                End Select
            End Get
        End Property
    End Class
End Namespace
