﻿Imports System.Text
Imports System.Threading.Tasks

Namespace JeuAvecDesKilometres
    Public MustInherit Class Carte
        Implements IComparable(Of Carte)
        ''' <summary>
        ''' Constructeur protégé, seules les classes filles pourront l'appeler
        ''' </summary>
        ''' <param name="CheminDeLimage"></param>
        ''' <param name="LesPoints"></param>
        Protected Sub New(ByVal CheminDeLimage As String, ByVal LesPoints As Integer)
            CheminImage = CheminDeLimage
            Points = LesPoints
        End Sub

        ''' <summary>
        ''' Chemin vers l'image de la face
        ''' </summary>
        ''' <remarks>C'est la couche Vue qui s'occupera de l'afficher</remarks>
        Private privateCheminImage As String
        Public Property CheminImage As String
            Get
                Return privateCheminImage
            End Get
            Private Set(ByVal value As String)
                privateCheminImage = value
            End Set
        End Property

        ''' <summary>
        ''' Nombre de points marqués avec cette carte
        ''' </summary>
        Private privatePoints As Integer
        Public Property Points As Integer
            Get
                Return privatePoints
            End Get
            Protected Set(ByVal value As Integer)
                privatePoints = value
            End Set
        End Property

        ''' <summary>
        ''' Propriété pour le tri
        ''' </summary>
        Public MustOverride ReadOnly Property Ordre As Integer

        ''' <summary>
        ''' Implémentation de IComparable<Carte>
        ''' </summary>
        ''' <param name="other"></param>
        ''' <returns></returns>
        Public Function CompareTo(ByVal other As Carte) As Integer Implements IComparable(Of Carte).CompareTo
            Return Me.Ordre.CompareTo(other.Ordre)
        End Function
    End Class

End Namespace
