﻿Imports System.Text
Imports System.Threading.Tasks

Namespace JeuAvecDesKilometres
    Public Class Kilometre
        Inherits Carte
        Public Sub New(ByVal CheminDeLimage As String, ByVal LesKilometres As Integer) 'on appelle le constructeur de Carte
            MyBase.New(CheminDeLimage, LesKilometres)
            Distance = LesKilometres
        End Sub

        Private privateDistance As Integer
        Public Property Distance As Integer
            Get
                Return privateDistance
            End Get
            Private Set(ByVal value As Integer)
                privateDistance = value
            End Set
        End Property

        ''' <summary>
        ''' Réécriture de ToString pour afficher le nombre de kilomètres
        ''' </summary>
        ''' <returns></returns>
        Public Overrides Function ToString() As String
            Return Distance.ToString() & " km"
        End Function

        ''' <summary>
        ''' Méthode de classe qui génère la liste de Kilomètres
        ''' </summary>
        ''' <returns></returns>
        Public Shared Function Generer() As List(Of Carte)
            Dim resultat As New List(Of Carte)()

            For i As Integer = 0 To 9
                resultat.Add(New Kilometre("Image 25 km", 25))
            Next i

            For i As Integer = 0 To 9
                resultat.Add(New Kilometre("Image 50 km", 50))
            Next i

            For i As Integer = 0 To 9
                resultat.Add(New Kilometre("Image 75 km", 75))
            Next i

            For i As Integer = 0 To 11
                resultat.Add(New Kilometre("Image 100 km", 100))
            Next i

            For i As Integer = 0 To 3
                resultat.Add(New Kilometre("Image 200 km", 200))
            Next i


            Return resultat
        End Function

        ''' <summary>
        ''' Opérateur qui permet d'additionner deux Kilometre et de retourner un entier égal à la somme des distances.
        ''' </summary>
        ''' <param name="LUn"></param>
        ''' <param name="LAutre"></param>
        ''' <returns></returns>
        Public Shared Operator +(ByVal LUn As Kilometre, ByVal LAutre As Kilometre) As Integer
            Return LUn.Distance + LAutre.Distance
        End Operator

        ''' <summary>
        ''' Opérateur qui permet d'additionner un Kilometre et un entier
        ''' </summary>
        ''' <param name="Km"></param>
        ''' <param name="Entier"></param>
        ''' <returns></returns>
        Public Shared Operator +(ByVal Km As Kilometre, ByVal Entier As Integer) As Integer
            Return Km.Distance + Entier
        End Operator

        ''' <summary>
        ''' Implémentation de ordre Kilometre
        ''' </summary>
        Public Overrides ReadOnly Property Ordre As Integer
            Get
                Return Distance + 20
            End Get
        End Property
    End Class
End Namespace
