﻿Imports System.Text
Imports System.Threading.Tasks

Namespace JeuAvecDesKilometres
    Public Class Parade
        Inherits Carte
        Public Sub New(ByVal CheminImage As String, ByVal LeType As TypeEmbuche)
            MyBase.New(CheminImage, 0)
            EmbucheParee = LeType
        End Sub

        Private privateEmbucheParee As TypeEmbuche
        Public Property EmbucheParee As TypeEmbuche
            Get
                Return privateEmbucheParee
            End Get
            Private Set(ByVal value As TypeEmbuche)
                privateEmbucheParee = value
            End Set
        End Property

        ''' <summary>
        ''' Réécriture de ToString pour afficher le nom de la parade
        ''' </summary>
        ''' <returns></returns>
        Public Overrides Function ToString() As String
            Select Case EmbucheParee
                Case TypeEmbuche.Accident
                    Return "Réparation"

                Case TypeEmbuche.Crevaison
                    Return "Roue de secours"

                Case TypeEmbuche.FeuRouge
                    Return "Feu vert"

                Case TypeEmbuche.LimitationVitesse
                    Return "Fin de limitation"

                Case TypeEmbuche.PanneEssence
                    Return "Station essence"

                Case Else 'on est obligé de mettre un default ou après le switch return quelque chose car ToString retourne un résultat, et même si on a testé toutes les options de TypeEmbuche, le compilateur considère qu'un cas non prévu pourrait se présenter et qu'il n'y aurait alors pas de résultat
                    Return "Erreur"
            End Select
        End Function

        ''' <summary>
        ''' Méthode de classe qui génère la liste de Parades
        ''' </summary>
        ''' <returns></returns>
        Public Shared Function Generer() As List(Of Carte)
            Dim resultat As New List(Of Carte)()

            For i As Integer = 0 To 13
                resultat.Add(New Parade("Image du feu vert", TypeEmbuche.FeuRouge))
            Next i

            For i As Integer = 0 To 5
                resultat.Add(New Parade("Image de la fin de limitation", TypeEmbuche.LimitationVitesse))
            Next i

            For i As Integer = 0 To 5
                resultat.Add(New Parade("Image de la station essence", TypeEmbuche.PanneEssence))
            Next i

            For i As Integer = 0 To 5
                resultat.Add(New Parade("Image de la roue de secours", TypeEmbuche.Crevaison))
            Next i

            For i As Integer = 0 To 5
                resultat.Add(New Parade("Image de la réparation", TypeEmbuche.Accident))
            Next i

            Return resultat
        End Function

        ''' <summary>
        ''' Implémentation de ordre dans Parade
        ''' </summary>
        Public Overrides ReadOnly Property Ordre As Integer
            Get
                If EmbucheParee = TypeEmbuche.FeuRouge Then
                    Return 4
                Else
                    Return CInt(EmbucheParee) + 4
                End If
            End Get
        End Property

    End Class
End Namespace
