﻿Imports System.ComponentModel
Imports System.Text
Imports System.Threading.Tasks
Imports JeuAvecDesKilometres 'pour pouvoir me réfèrer à cet espace de nom, j'ai d'abord mis la réfèrence au projet JeuAvecDesKilometres dans le porjet actuel

Namespace Tuto_Objets_Csharp_winform
    Partial Public Class Form1
        Inherits Form
        Public Sub New()
            InitializeComponent()
        End Sub

        Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
            Dim nomsJoueurs As New Dictionary(Of String, Difficulte)()
            nomsJoueurs.Add("Joueur A", Difficulte.Normale)
            nomsJoueurs.Add("Joueur B", Difficulte.Normale)
            nomsJoueurs.Add("Joueur C", Difficulte.Normale)

            Moteur.InitPremierePartie(nomsJoueurs)

            'Début débug

            'on remets les cartes dans la pioche
            For Each j As Joueur In Moteur.Joueurs
                For Each c As Carte In j.Main
                    Moteur.Pioche.Add(c)
                Next c

                j.Main.Clear()
            Next j


            Dim laCarte As Carte = Moteur.Pioche.OfType(Of Botte)().Single(Function(b) b.EmbucheImmunisee.HasFlag(TypeEmbuche.FeuRouge)) 'on donne le camion de pompier à A
            Moteur.Joueurs(0).Main.Add(laCarte)
            Moteur.Pioche.Remove(laCarte)

            laCarte = Moteur.Pioche.OfType(Of Botte)().Single(Function(b) b.EmbucheImmunisee.HasFlag(TypeEmbuche.Accident)) 'on donne l'As du Volant à A
            Moteur.Joueurs(0).Main.Add(laCarte)
            Moteur.Pioche.Remove(laCarte)

            Dim kms = Moteur.Pioche.OfType(Of Kilometre)().Where(Function(k) k.Distance = 100) 'on donne des 100km à A
            For i As Integer = 0 To 4
                Dim c As Carte = kms.First()
                Moteur.Pioche.Remove(c)
                Moteur.Joueurs(0).Main.Add(c)

            Next i

            laCarte = Moteur.Pioche.First(Function(c) TypeOf c Is Embuche AndAlso (CType(c, Embuche)).Type.HasFlag(TypeEmbuche.Accident)) 'on donne un Accident à B
            Moteur.Pioche.Remove(laCarte)
            Moteur.Joueurs(1).Main.Add(laCarte)
            For i As Integer = 0 To 4 'On pioche normalement pour B et C
                Moteur.Joueurs(1).Pioche()
                Moteur.Joueurs(2).Pioche()
            Next i
            Moteur.Joueurs(2).Pioche()


            'fin débug

            AddHandler Moteur.PartieGagnee, AddressOf Moteur_PartieGagnee
            AddHandler Moteur.ProchainJoueur, AddressOf Moteur_ProchainJoueur
            AddHandler Moteur.NouvellePioche, AddressOf Moteur_NouvellePioche
            AddHandler Moteur.CarteInterdite, AddressOf Moteur_CarteInterdite
            AddHandler Moteur.CoupFourre, AddressOf Moteur_CoupFourre
            AddHandler Moteur.JoueurDisqualifie, AddressOf Moteur_JoueurDisqualifie
            AddHandler Moteur.PiocheDabord, AddressOf Moteur_PiocheDabord

            Moteur_ProchainJoueur(Moteur.JoueurEnCours)

            TousLesBinding()
        End Sub

        Private Sub Moteur_PiocheDabord(ByVal LeJoueur As Joueur)
            AfficheMessage(LeJoueur.Nom & " doit piocher avant de jouer.")
        End Sub

        Private Sub Moteur_JoueurDisqualifie(ByVal LeJoueur As Joueur)
            AfficheMessage(LeJoueur.Nom & " a dépassé la distance, il est disqualifié!")
        End Sub

        Private Sub Moteur_CoupFourre()
            AfficheMessage("Coup fourré!")
        End Sub

        Private Sub Moteur_CarteInterdite(ByVal LeJoueur As Joueur, ByVal LaCarte As Carte, ByVal Raison As Interdictions)
            Dim messages() As String = {"Joueur immunisé","Limitation de vitesse","Embûche à parer","2 cartes 200 km maximum","Parade inutile", "Parez l'embûche avant de poser le feu vert","La cible est déjà attaquée","Joueur déjà bridé", "Carte interdite pour une raison inconnue","Distance dépassée","Veuillez patienter","Ce n'est pas votre tour","Pioche interdite"}
            AfficheMessage(messages(CInt(Raison)))
        End Sub

        Private Sub Moteur_NouvellePioche()
            lblPioche.Text = String.Format("La pioche contient" & Environment.NewLine & "{0} cartes.", Moteur.Pioche.Count)
            TousLesBinding()
        End Sub

        Private Sub Moteur_ProchainJoueur(ByVal LeJoueur As Joueur)
            lblA.BackColor = Color.Transparent
            lblB.BackColor = Color.Transparent
            lblC.BackColor = Color.Transparent


            Select Case Moteur.Joueurs.IndexOf(LeJoueur)
                'mets le nom du joueur en vert
                Case 0
                    lblA.BackColor = Color.Lime

                Case 1
                    lblB.BackColor = Color.Lime

                Case 2
                    lblC.BackColor = Color.Lime
            End Select

            butPiocher.Visible = LeJoueur.Niveau <> Difficulte.Facile

        End Sub

        Private Sub Moteur_PartieGagnee(ByVal LeJoueur As Joueur)
            TousLesBinding()

            Dim lautre As Joueur = Moteur.Joueurs.Single(Function(j) j IsNot LeJoueur)
            Dim str As New StringBuilder(LeJoueur.Nom)
            str.AppendLine(" a gagné!")
            str.AppendLine(String.Format("{0} marque {1} points.", LeJoueur.Nom,LeJoueur.Points))
            str.AppendLine(String.Format("{0} marque {1} points.", lautre.Nom, lautre.Points))


            MessageBox.Show(str.ToString())

            Moteur.NouvellePartie()
        End Sub

        Private Sub butPiocher_Click(ByVal sender As Object, ByVal e As EventArgs)
            Dim leJoueur As Joueur = Moteur.JoueurEnCours
            leJoueur.Pioche()

            Dim lst As ListBox
            If leJoueur Is Moteur.Joueurs(0) Then
                lst = lstMainA
            Else
                lst = lstMainB
            End If

            TousLesBinding()
        End Sub

            Private laCarte As Carte
            Private joueur As Joueur
        Private Sub butJouer_Click(ByVal sender As Object, ByVal e As EventArgs) Handles butJouerA.Click, butJouerB.Click, butJouerC.Click

            If sender Is butJouerA Then
                laCarte = CType(lstMainA.SelectedItem, Carte)
                joueur = Moteur.Joueurs(0)
            ElseIf sender Is butJouerB Then
                laCarte = CType(lstMainB.SelectedItem, Carte)
                joueur = Moteur.Joueurs(1)
            Else
                laCarte = CType(lstMainC.SelectedItem, Carte)
                joueur = Moteur.Joueurs(2)
            End If



            If TypeOf laCarte Is Embuche Then

                lstCible.DataSource = Nothing
                lstCible.DataSource = Moteur.Joueurs.Except( { joueur }).ToList()
                lstCible.SelectedItem = -1
                lstCible.Visible = True
                Return
            ElseIf TypeOf laCarte Is Kilometre Then
                joueur.Jouer(CType(laCarte, Kilometre))
            ElseIf TypeOf laCarte Is Parade Then
                joueur.Jouer(CType(laCarte, Parade))
            Else
                joueur.Jouer(CType(laCarte, Botte))
            End If

            TousLesBinding()
        End Sub

        Private Sub butDefausser_Click(ByVal sender As Object, ByVal e As EventArgs) Handles butDefausser.Click
            Dim laCarte As Carte
            If (Moteur.JoueurEnCours.Equals(Moteur.Joueurs(0))) Then
                laCarte = CType(lstMainA.SelectedItem, Carte)
            ElseIf (Moteur.JoueurEnCours.Equals(Moteur.Joueurs(1))) Then
                laCarte = CType(lstMainB.SelectedItem, Carte)
            Else
                laCarte = CType(lstMainC.SelectedItem, Carte)
            End If

            Moteur.JoueurEnCours.Defausse(laCarte)
            TousLesBinding()
        End Sub

        Private Sub TousLesBinding()
            lstJeuA.DataSource = Nothing
            lstJeuB.DataSource = Nothing
            lstJeuC.DataSource = Nothing
            lstMainA.DataSource = Nothing
            lstMainB.DataSource = Nothing
            lstMainC.DataSource = Nothing

            lblMainA.Text = String.Format("Main, {0} cartes", Moteur.Joueurs(0).Main.Count)
            lstMainA.DataSource = Moteur.Joueurs(0).Main
            lstJeuA.DataSource = Moteur.Joueurs(0).Jeu
            lblJeuA.Text = Moteur.Joueurs(0).DistanceParcourue.ToString() & " km"
            lblImmuniteA.Text = Moteur.Joueurs(0).Immunite.ToString()
            lblEmbuchesA.Text = Moteur.Joueurs(0).EmbucheEnCours.ToString()

            lblMainB.Text = String.Format("Main, {0} cartes", Moteur.Joueurs(1).Main.Count)
            lstMainB.DataSource = Moteur.Joueurs(1).Main
            lstJeuB.DataSource = Moteur.Joueurs(1).Jeu
            lblJeuB.Text = Moteur.Joueurs(1).DistanceParcourue.ToString() & " km"
            lblImmuniteB.Text = Moteur.Joueurs(1).Immunite.ToString()
            lblEmbuchesB.Text = Moteur.Joueurs(1).EmbucheEnCours.ToString()

            lblMainC.Text = String.Format("Main, {0} cartes", Moteur.Joueurs(2).Main.Count)
            lstMainC.DataSource = Moteur.Joueurs(2).Main
            lstJeuC.DataSource = Moteur.Joueurs(2).Jeu
            lblJeuC.Text = Moteur.Joueurs(2).DistanceParcourue.ToString() & " km"
            lblImmuniteC.Text = Moteur.Joueurs(2).Immunite.ToString()
            lblEmbuchesC.Text = Moteur.Joueurs(2).EmbucheEnCours.ToString()

            lstDefausse.DataSource = Nothing
            lstDefausse.DataSource = Moteur.Defausse

            lblPioche.Text = String.Format("La pioche contient" & Environment.NewLine & "{0} cartes.", Moteur.Pioche.Count)

        End Sub

        Private Sub AfficheMessage(ByVal Message As String)
            LblAnnonce.Text = Message
            timer1.Start()
        End Sub

        Private Sub timer1_Tick(ByVal sender As Object, ByVal e As EventArgs) Handles timer1.Tick
            If timer1.Interval = 10 Then
                timer1.Interval = 3000
                LblAnnonce.Visible = True
            Else
                timer1.Stop()
                timer1.Interval = 10
                LblAnnonce.Visible = False
            End If

        End Sub

        Private Sub butPiocher_Click_1(ByVal sender As Object, ByVal e As EventArgs) Handles butPiocher.Click
            Moteur.JoueurEnCours.Pioche()

            TousLesBinding()
        End Sub

        Private Sub lstCible_Click(ByVal sender As Object, ByVal e As EventArgs) Handles lstCible.Click
            joueur.Jouer(CType(laCarte, Embuche), CType(lstCible.SelectedItem, Joueur))
            lstCible.Visible = False
            TousLesBinding()
        End Sub
    End Class
End Namespace
